
#include "base.h"
#include "estad.h"
// #include <stdio.h>

#define MAXLIN 400

//:f:
//  entrada  - un vector: v   y su tamao: n
//           - un del(ta)
//  salida   - un vector de centros de grupo: cg  y su numero: ng
//           - un vector numero de elemento en grupo  (mismo numero)
//                salidas con memoria prev. asignada
void agrupa0 (int cg[], int neng[], int *ng, int v[], int n, int del)
{
  int quedan;
  int agrupado [MAXLIN];
  int maxacum, acum;
  int x, cen1, cen2, cen, xmax, xmin;
  int i;
  int prim;
  int j;
  j = 0;
  for (i=0; i<n; i++)
    agrupado [i] = FALSE;
  quedan = n; 
  xmin = minv (v, n);
  xmax = maxv (v, n);
  // printf ("xmin:%4d, xmax: %4d\n", xmin, xmax);
  while (quedan > 1) {
    // una iteracion, un grupo
    maxacum = 0;
    prim = TRUE;
    for (x=(xmin-del); x<=(xmax+del); x++){
      acum = 0;
      for (i=0; i<n; i++)
        if (!agrupado [i] && (v[i] >= x-del) && (v[i] <= x+del))
          acum ++;
      if (acum > maxacum){
	cen1 = x;
	cen2 = x;
	maxacum = acum;
	}
      else if (prim) {
        if (acum == maxacum)
	  cen2 = x;
	if (acum < maxacum) 
          prim = FALSE;
        }
      }
    // centro del primer grupo de menor a mayor 
    cg[j] = cen = (cen1 + cen2) / 2;
    for (i=0; i<n; i++){
      if ((v[i] >= cen-del) && (v[i] <= cen+del))
	agrupado [i] = TRUE;
      }
    quedan -= maxacum;
    neng[j] = maxacum;
    j++;
    }
  if (quedan == 1) {
    for (i=0; i<n; i++){
      if (!agrupado [i]){
	cg[j++] = v[i];
	quedan --;
        }
      }
    }
  // for (i=0; i<j; i++)
  //   printf ("cg[%4d]: %4d\n", i, cg[i]);
  *ng = j;
}

void agrupa (int cg[], int *ng, int v[], int n, int del)
{
  int neng [MAXLIN];
  agrupa0 (cg, neng, ng, v, n, del);
}
