
#include <string.h>

#include "imagAcum.h"
#include "glifos.h"

typedef struct techarImagacum{
  char * chars;
  timagAcum imagAc;
  } * tcharImagacum;

void anyadeImagenDeglifoCar (tglifo glifoCar, tpgen datos)
{
  tcharImagacum charImagAcum;
  charImagAcum = (tcharImagacum) datos;
  if (glifoCar->recon != reconNulo) {
    if (strcmp (glifoCar->letras, charImagAcum->chars) == 0)
      anyadeImagAcum (charImagAcum->imagAc, glifoCar->venDeGlifo);
    }
}

timagAcum imagenAcumDecharsEnglifo (int ampl, char *chs, tglifo glifo)
{
  struct techarImagacum charImagacum;
  charImagacum.chars  = chs;
  charImagacum.imagAc = creaImagenAcum (ampl);
  aplicaGtRFncD (glifo, glifCar,
		 anyadeImagenDeglifoCar, (tpgen) &charImagacum);
  return charImagacum.imagAc; 
}
