
#include "imag.h"

#ifndef TFD2D
#define TFD2D
typedef struct tecomplejo {
  double pr, pi;
  } tcomplejo, **tmatcomplejo;

typedef struct tecomplejo *tveccomplejo;

#define TF_TAMMAXY 220

#endif

void liberaMatrizComplejo (tmatcomplejo m, int ty);

/*
void transfRect (tmatcomplejo *nm, tvent vent, 
                 int x0, int y0, int tx, int ty);
*/

void liberaVectorComplejo (tveccomplejo v);

void transfVectNormSeg (tveccomplejo vc, int tx);

void transfVector (tveccomplejo *nv, int *vec, int t);

void transfVent0 (tmatcomplejo *nm, tvent vent);

void transfVent (tmatcomplejo *nm, tvent vent);

void transfVentDI (timagf *nimag, tvent vent);

void escribe1tr (tmatcomplejo m, int nx, int ny);

void modulosnVecc (int **nvm, tveccomplejo vc, int t);

void modulosnVeccTr (double **nvm, tveccomplejo vc, int t, int alt);

void escribe0tr (tveccomplejo v, int t);

