
#include "imag0.h"
#include "lista.h"

typedef struct teline{
  int u0, v0, u1, v1;
  char hv;
  char bn;
  int incl;
  } * tline;

typedef struct teline2{
  int u0, v00, v01, u1, v10, v11;
  char hv;
  char bn;
  int incl;
  } * tline2;

// -------------------- --------------------

tline2 nuevaRaya20 ();

tline nuevaRaya (int u0, int v0, int u1, int v1);

tline copiaRaya (tline line);

tline desplazadauRaya (tline line, int du);

void leeRaya (tline *line);

void leeRayas (lista *nlineas);

void imprimeRaya (tline line);

void imprimeRayas (lista lineas);

void imprimeRayasCab (lista lineas, char *text);

void imprimeGruposRayasCab (lista grLineas, char *text);

void tomaLineasLim (lista *nlineasLim, lista blin, int tamv);

void eliminaLineasMenores (lista lineas, int tumin);

void eliminaLineasMasanchas (lista lineas, int tvmax);

void eliminaLineasMenosanchas (lista lineas, int tvmin);

int u0_de_linea (tpgen l);
int u1_de_linea (tpgen l);
int v0_de_linea (tpgen l);
int v1_de_linea (tpgen l);

// -------------------- --------------------


void line2de1 (tline2 l2, tline l);

void line1de2 (tline l, tline2 l2);


// -------------------- --------------------

tline mayorRaya (lista lineas);

void ordenadasRayas (lista *nlisneasOrd, lista lin);

void uneLineasProximas (lista lineas, int dist);

// -------------------- --------------------

void sigueyAgrupaRayasHor (lista *nlineasAgr, tvent vent);

void sigueyAgrupaPunteadasHor (lista *nlineasAgr, tvent vent, int dist, int lmin);

void sigueyAgrupaRayasVer (lista *nlineasAgr, tvent vent);

void sigueyAgrupaPunteadasVer (lista *nlineasAgr, tvent vent, int dist, int lmin);

void sigueyAgrupaRayasHorBlan (lista *nlineasAgr, tvent vent, int lmin);

void sigueyAgrupaRayasVerBlanLar (lista *nlineasAgr, tvent vent);

void pintaAlrededorRaya (tline line, tvent vent, int n);

void pintaAlrededorRayas (lista lineas, tvent vent, int n);

void sigueRayas (tvent vent);

void sigueRayasN (tvent vent, int n);

void sigueRayasBlanLar (tvent vent);

void sigueyAgrupaRayasVerBlanIncl (lista *nlineasAgr, tvent vent, int lmin, int incl);


// -------------------- --------------------

int sumaAnchoRayasBlanLarIncl (tvent vent, int incl256);

void posicionLineaCabecera (tline *nlinea, tvent vent);

void posicionMargenColumnas (tline *nlinea, tvent vent);

// void posicionMargenesSeccion (tline *nlinea, tvent vent);

void posicionesMargenesSeccion (lista *nlineas, tvent vent);

// void posicionMargenesMinipage (tline *nlinea, tvent vent);

void posicionesMargenesMinipage (lista *nlineas, tvent vent);

// -------------------- --------------------

lista cortesHorizontalesyVerticales (tvent vent);

void pruebaLine ();

Boolean seCortan (tline l1, tline l2);

void agrupaLineasQueSeCortan (lista *ngrupos,
                              lista lineasH, lista lineasV);

void agrupaLineasContinuas (lista *nlineasc, lista lineas, int margen_u, int margen_v);

lista lineasdeOrientacion (lista l, char c);

int nlineasMasLargas (lista *lineasLargas, lista lineasagr, int nmax);

void ordenaPor_vx (lista *lineasLargasOv, lista lineasLargas);

Boolean seCortan2 (tline l1, tline l2);

void eliminadasLineasCortadas (lista * lineasVsc, lista lineasV, lista lineasH);  // o H/V

void delimitaParalelogrInterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del);

void delimitaParalelogrExterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del);

