
#include <stdio.h>

#include "base.h"
#include "glifos.h"
#include "grises.h"
#include "imag.h"
// #include "inclfont.h"
#include "inclina.h"
#include "inclina0.h"
#include "opcns.h"
#include "parecido.h"

// int umbralComparaSuperpK = 7940 ;
// int umbralComparaSuperpK =  1 ;
 int umbralComparaSuperpK = 20 ;   // 20 <<<<<
 int umbralComparaSuperpK2 = 80 ;   /* comparaVent2max */
// int umbralComparaSuperpK = 415 ;    /*    <<<<< 40 */
 int umbralComparaSuperp ;

void inicia_umbralComparaSuperp ()
{
  if (x_opcion)
    umbralComparaSuperp = umbralComparaSuperpK2;
  else
    umbralComparaSuperp = umbralComparaSuperpK;
  if (T_opcion)
    umbralComparaSuperp *= T_valori ;
}

int compara1 (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed)
{
  int ace;
  int x, y;
  int xx1, xx2, yy1, yy2;
  int  xxx, yyy;
  int ab, ab2;
  int dif;
  ace=0;
  for(x=0; x<tx; x++)
  for(y=0; y<ty; y++){
    xx1=dx1+x;
    xx2=dx2+x;
    yy1=dy1+y;
    yy2=dy2+y;
    ab = 255;
    for(xxx=xx2-1;xxx<=xx2+1;xxx++)
    for(yyy=yy2-1;yyy<=yy2+1;yyy++){
      dif = (pix1[yy1][xx1] & 0xFF) - (pix2[yyy][xxx] & 0xFF) - difmed ;
      ab = min(ab,abs(dif));
      }
    /**/
    ab2 = (ab * ab) / 16 ;
    ace += (ab2 * ab2) / 8 ;
    /** /
    ab2 = (ab * ab) / 8 ;
    ace += (ab2 * ab2) / 1 ;
    / **/
    }
  ace /= tx*ty ;
  return ace;
}

int compara1Incl (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed, int inc)
{
  int ace;
  int x, y;
  int xx1, xx2, yy1, yy2;
  int  xxx, yyy;
  int ab, ab2;
  int dif;
  int xp, xu, xi;
  int txi;
  int dxs;
  pon_vprim_vult (inc, ty, tx, &xp, &xu) ;
  ace=0;
  for(x=xp; x<=xu; x++)
  for(y=0; y<ty; y++){
    xi = x + inclf_desvx(inc, y);
    xx1=dx1+xi;
    xx2=dx2+xi;
    yy1=dy1+y;
    yy2=dy2+y;
    ab = 255;
    for(xxx=xx2-1;xxx<=xx2+1;xxx++)
    for(yyy=yy2-1;yyy<=yy2+1;yyy++){
      dif = (pix1[yy1][xx1] & 0xFF) - (pix2[yyy][xxx] & 0xFF) - difmed ;
      ab = min(ab,abs(dif));
      }
    ab2 = (ab * ab) / 16 ;
    ace += (ab2 * ab2) / 8 ;
    }
  dxs = inclf_desvx(inc, ty-1);
  txi = tx - abs(dxs);
  if (txi*ty != 0)
    ace /= txi*ty ;
  else
    ace = DISTGRANDE ;
  return ace;
}

// no usado, pruebas
int compara2 (char **pix1, char **pix2,
              int dx1, int dx2, int dy1, int dy2,
              int tx, int ty, int difmed)
{
  int ac;
  int ace, ex, ey;
  int xdes, ydes;
  xdes=1;
  ydes=1;
  ac = DISTGRANDE ;                      /* numero muy grande <<< */
  for(ex=-xdes ;ex<=xdes ;ex++)
  for(ey=-ydes ;ey<=ydes ;ey++){
    ace = compara1 (pix1, pix2, dx1, dx2+ex, dy1, dy2+ey, tx, ty, difmed);
    if (ace < ac) ac = ace;
    }
  return ac;
}

int comparaVent (tvent vent1, tvent vent2)
{
  int ac;
  int margenDim;
  int difmed;
  char ** pix1, ** pix2;
  int tx, ty;
  int dx1, dx2, dy1, dy2;
  ac = DISTGRANDE ;                      /* numero muy grande <<< */
  margenDim = 2 + vent2->ty / 30;
  if ((abs(vent1->tx - vent2->tx) <= margenDim) &&
      (abs(vent1->ty - vent2->ty) <= margenDim) &&
          (vent1->ty > 0)  &&  (vent2->ty > 0) ) {
    difmed = mediaGrVentana (vent1) - mediaGrVentana (vent2) ;
    pix1 = vent1->imaBase->ven0->pix ;
    dx1 = vent1->dx;
    dy1 = vent1->dy;
    pix2 = vent2->imaBase->ven0->pix ;
    dx2 = vent2->dx;
    dy2 = vent2->dy;
    tx = max(vent1->tx, vent2->tx);
    ty = max(vent1->ty, vent2->ty);
    if (dy2 == 0) {
      dy2 = 1;
      ty = max(vent1->ty, vent2->ty - 1);
      }
    // printf ("dx1:%4d, dx2:%4d, dy1:%4d, dy2:%4d, vent1->tx:%4d, vent1->ty:%4d, vent2->tx:%4d, vent2->ty:%4d, ty:%4d\n",
    //       dx1, dx2, dy1, dy2, vent1->tx, vent1->ty, vent2->tx, vent2->ty, ty);
    // if (ty + dy2 >= vent2->imaBase->ven0->ty) ty = vent2->imaBase->ven0->ty - dy2 - 1;
    // printf (" ty:%4d\n", ty);
      /* suponemos que ty >= 0, falta id. y=0, y x.. */
    if ((tx == 0) || (ty == 0))
      ac = DISTGRANDE ;
    else if ((ty + dy1 >= vent1->imaBase->ven0->ty) ||
             (ty + dy2 >= vent2->imaBase->ven0->ty)) {
      ac = DISTGRANDE ;
      }
    else if (vent1->incl == 0) {
      ac = compara1 (pix1, pix2, dx1, dx2, dy1, dy2, tx, ty, difmed);
      }
    else
      ac = compara1Incl (pix1, pix2, dx1, dx2, dy1, dy2, tx, ty, difmed, vent1->incl);
    }
  if (d_valori >= 30)
    printf ("ocre: comparaVent, %10d\n", ac) ;
  return ac ;
}

int comparaVent2max (tvent vent1, tvent vent2)
{
  int d1, d2;
  d1 = comparaVent(vent1, vent2);
  // d2 = comparaVent(vent2, vent1);
  if (x_opcion)
    return d1;
  else {
    d2 = comparaVent(vent2, vent1);
    return max(d1,d2) ;
    }
}

int ventParecidaAntes (tglifo *glifoParecido, tvent vent)
{
  int encontrado ;
  int distancia = DISTGRANDE ;        /* numero muy grande <<< */
  tnodolglifo nlglifo;
  encontrado = FALSE ;
  nlglifo = lglmuestra->primero ;
  while (nlglifo != (tnodolglifo) 0L) {
    //       AQUI estoy: mié dic  3 20:27:52 CET 2008
    // distancia = comparaVent (nlglifo->aglifo->venDeGlifo, vent) ;
    distancia = comparaVent2max (nlglifo->aglifo->venDeGlifo, vent) ;
    if ( distancia < umbralComparaSuperp ) {
       *glifoParecido = nlglifo->aglifo ;
       encontrado = TRUE;
       if (d_valori >= 30)
         printf ("ocre: ventParecidaAntes, %s\n", nlglifo->aglifo->letras) ;
       break;
       }
    nlglifo = nlglifo->siguiente ;
    }
  if (d_valori >= 20) {
    if (encontrado) {
      printf ("encontrado: distancia = %d\n", distancia);
      describeVentana (vent);
      describeVentana ((*glifoParecido)->venDeGlifo);
      }
    else
      printf ("NO encontrado:\n");
    }
  return encontrado;
/*
  return FALSE;
*/
}

int glifParecidoYensusitioAntes (tglifo *glifoParecido, tglifo glifoChar)
{
  int encontrado ;
  int distancia = DISTGRANDE ;        /* numero muy grande <<< */
  tnodolglifo nlglifo;
  tvent vent;
  int baseAct, alturaxAct, baseAntes, alturaxAntes;
  vent = glifoChar->venDeGlifo;
  encontrado = FALSE ;
  nlglifo = lglmuestra->primero ;
  baseyalturaxDeGlifo (& baseAct,   & alturaxAct,   glifoChar);
  while (nlglifo != (tnodolglifo) 0L) {
    distancia = comparaVent (nlglifo->aglifo->venDeGlifo, vent) ;
    if ( distancia < umbralComparaSuperp ) {
       *glifoParecido = nlglifo->aglifo ;
       /* if (base(glifoParecido) ~ base(glifoChar)) */
       baseyalturaxDeGlifo (& baseAntes, & alturaxAntes, *glifoParecido);
       /*
       printf (" bac: %5d alac: %5d ban: %5d alan: %5d, brac: %5d, bran: %5d\n",
                 baseAct, alturaxAct, baseAntes, alturaxAntes,
		 vent->dy - baseAct, (*glifoParecido)->venDeGlifo->dy - baseAntes);
		 */
       if (abs((baseAntes - (*glifoParecido)->venDeGlifo->dy) -
               (baseAct   -                         vent->dy) ) <= 3 ) {
         encontrado = TRUE;
         if (d_valori >= 30)
           printf ("ocre: glifParecidoYensusitioAntes, %s\n", nlglifo->aglifo->letras) ;
         break;
         }
       }
    nlglifo = nlglifo->siguiente ;
    }
  if (d_valori >= 20) {
    if (encontrado) {
      printf ("encontrado: distancia = %d\n", distancia);
      describeVentana (vent);
      describeVentana ((*glifoParecido)->venDeGlifo);
      }
    else
      printf ("NO encontrado:\n");
    }
  return encontrado;
/*
  return FALSE;
*/
}

